@function list-depth($list) {
  $depth: 0;
  $current: $list;

  @while true {
    @if type-of($current) != list {
      @return $depth;
    }

    $depth: $depth + 1;

    @if list.length($current) < 1 {
      @return $depth;
    }

    $current: list.nth($current, 1);
  }
}

@function list-up-depth-to($list, $depth) {
  @for $i from list-depth($list) to $depth {
    $list: list.append((), $list);
  }

  @return $list;
}

@function list-to-map($reversed, $args...) {
  $r: ();

  @if (list.length($args) == 0) {
    @return $r;
  }

  $keys: iif(type-of(list.nth($args, 1)) == list, list.nth($args, 1), $args);

  @for $i from 1 through list.length($keys) {
    $k: list.nth($keys, $i);
    @if (type-of($k) != string) {
      @error 'list-to-map only list of strings supported';
    }

    $v: list.nth($keys, iif($reversed, -$i, $i));

    $r: map.set($r, $k, $v);
  }

  @return $r;
}
